int linearSearch(int array[], int key, int size)
/* Ricerca lineare di una chiave in un vettore di interi
 * array: vettore in cui ricercare la chiave
 * key: chiave da ricercare
 * size: dimensione del vettore
 */
{
   int n;

   for (n = 0; n <= size - 1; ++n)
      if (array[n] == key)
         return n;

   return -1;
}

#ifdef __iterativa__

int binarySearch(int b[], int key, int low, int high)
/* Ricerca binaria di una chiave key nell'intervallo [low, high]
 * di un vettore ordinato di interi b
 * Precondizione: low <= high e b ordinato (crescente)
 * Ritorna -1 se la chiave non e' presente nel vettore,
 * oppure, la posizione della chiave nel vettore.
 *
 * Versione iterativa
 */

{
   int middle;

   while (low <= high) {
      middle = (low + high) / 2;
      if (key == b[middle])  /* trovata */
         return middle;
      else if (key < b[middle]) /* cerca nella meta' inferiore */
         high = middle - 1;
      else /* cerca nella meta' superiore */
         low = middle + 1;
   }

   return -1;   /* non trovata */
}

#else

int binarySearch(int b[], int key, int low, int high)
/* Ricerca binaria di una chiave key nell'intervallo [low, high]
 * di un vettore ordinato di interi b
 * Precondizione: b ordinato (crescente)
 * Ritorna -1 se la chiave non e' presente nel vettore,
 * oppure, la posizione della chiave nel vettore.
 *
 * Versione ricorsiva
 */

{
   int middle = (low + high) / 2;

   if (low < high) /* intervallo vuoto: chiave non trovata */
       return -1;
   if (key == b[middle])  /* trovata */
      return middle;
   else if (key < b[middle]) /* cerca nella meta' inferiore */
      high = middle - 1;
   else /* cerca nella meta' superiore */
      low = middle + 1;
   /* cerca nel nuovo intervallo [high,low] */
   return binarySearch(b, key, low, high);
}

#endif
